/* RSAref.h */

#define RSAref_MIN_BITS		508
#define RSAref_MAX_BITS		1024
#define RSAref_MAX_LEN		((RSAref_MAX_BITS+7)/8)

typedef struct RSArefPublicKey_st
	{
	unsigned int bits;
	unsigned char m[RSAref_MAX_LEN];
	unsigned char e[RSAref_MAX_LEN];
	} RSArefPublicKey;

typedef struct RSArefPrivateKey_st
	{
	unsigned int bits;
	unsigned char m[RSAref_MAX_LEN];
	unsigned char e[RSAref_MAX_LEN];
	unsigned char d[RSAref_MAX_LEN];
	unsigned char prime[2][RSAref_MAX_LEN];	/* p & q */
	unsigned char pexp[2][RSAref_MAX_LEN];	/* dmp1 & dmq1 */
	unsigned char coef[RSAref_MAX_LEN];	/* iqmp */
	} RSArefPrivateKey;

typedef struct RSARandomState_st
	{
	unsigned int needed;
	unsigned char state[16];
	unsigned int output;
	unsigned char output[16];
	} RSARandomState;

